variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_VERSION: "24.0.5"
  DOCKER_TLS_CERTDIR: ""

  TF_ROOT: "${CI_PROJECT_DIR}/terraform"

.terraform:
  image: 
    name: ${CI_REGISTRY}/devops_includes/docker_images/ansible_terraform_packer:latest
    pull_policy: always
    entrypoint:
      - "/usr/bin/env"
      - "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"
  before_script:
    - cd $TF_ROOT
    - terraform init

.terraform fmt:
  extends: .terraform
  stage: lint
  script:
    - terraform fmt -check

.terraform validate:
  extends: .terraform
  stage: lint
  script: 
    - terraform validate

.terraform plan:
  extends: .terraform
  stage: plan
  script:
    - terraform plan -out="planfile"
  artifacts:
    paths:
      - "${TF_ROOT}/planfile"
    expire_in: 1 week

.terraform apply:
  extends: .terraform
  stage: deploy
  script:
    - terraform apply --auto-approve "planfile"
  artifacts:
    paths:
      - "${TF_ROOT}/terraform.tfstate"
    expire_in: 1 week


.terraform destroy:
  extends: .terraform
  stage: destroy
  script:
    - terraform destroy --auto-approve
  when: manual
